SystemOrganization addCategory: #'Equipment-TIT'!

Object subclass: #PLCInput
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipment-TIT'!

PLCInput subclass: #AnalogInput
	instanceVariableNames: 'pointValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipment-TIT'!

!AnalogInput methodsFor: 'initialize' stamp: 'PoncetAllemand 4/27/2012 14:26'!
initialize
	label := ''.
	pointValue := 0.! !

!AnalogInput methodsFor: 'Accesseurs' stamp: 'PoncetAllemand 4/27/2012 14:43'!
pointValue
	^ pointValue! !

!AnalogInput methodsFor: 'Accesseurs' stamp: 'PoncetAllemand 4/27/2012 15:16'!
pointValue: aSmallInteger 
	aSmallInteger < 0
		ifTrue: [ pointValue := 0]
		ifFalse: [
					aSmallInteger > 32767
						ifTrue: [ pointValue := 32767]
						ifFalse: [ pointValue := aSmallInteger].
				].
						
	
! !

PLCInput subclass: #DigitalInput
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipment-TIT'!

!DigitalInput methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 16:30'!
initialize
	state := false.! !

!DigitalInput methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 16:42'!
state
	^ state! !

!DigitalInput methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 16:17'!
stateOff
	state := false.! !

!DigitalInput methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 16:48'!
stateOn
	state := true.! !

!PLCInput methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 17:05'!
label
	^label.! !

!PLCInput methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 17:04'!
label: aByteString 
	label := aByteString! !

Object subclass: #RFGenerator
	instanceVariableNames: 'inputPwrOn inputRfOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipment-TIT'!

!RFGenerator methodsFor: 'initialize' stamp: 'PoncetAllemand 4/27/2012 16:30'!
initialize
	inputRfOn := DigitalInput new.
	inputPwrOn := DigitalInput new.! !

!RFGenerator methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 16:12'!
inputPwrOn: aDigitalInput 
	inputPwrOn := aDigitalInput.! !

!RFGenerator methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 16:55'!
inputRfOn: aDigitalInput 
	inputRfOn := aDigitalInput.! !

!RFGenerator methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 16:52'!
isRunning
		
	^ inputPwrOn state and:[inputRfOn state].! !

TestCase subclass: #TestAnalogInput
	instanceVariableNames: 'power'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipment-TIT'!

!TestAnalogInput methodsFor: 'as yet unclassified' stamp: 'PoncetAllemand 4/27/2012 15:26'!
setUp
	power := AnalogInput new.! !

!TestAnalogInput methodsFor: 'test' stamp: 'PoncetAllemand 4/27/2012 15:31'!
testAnalogInputLabelReturnName
	power label: 'QPW1'.
	self assert: power label equals: 'QPW1'.! !

!TestAnalogInput methodsFor: 'test' stamp: 'PoncetAllemand 4/27/2012 15:27'!
testAnalogInputLabelReturnNothing
	self assert: power label equals: ''.! !

!TestAnalogInput methodsFor: 'test' stamp: 'PoncetAllemand 4/27/2012 15:10'!
testAnalogInputPointValueReturn32767forHugeValue

	power pointValue: 40000.
	self assert: power pointValue equals: 32767.! !

!TestAnalogInput methodsFor: 'test' stamp: 'PoncetAllemand 4/27/2012 14:58'!
testAnalogInputPointValueReturnValue
	power pointValue: 15000.
	self assert: power pointValue  equals: 15000! !

!TestAnalogInput methodsFor: 'test' stamp: 'PoncetAllemand 4/27/2012 14:58'!
testAnalogInputPointValueReturnZero
	power label: 'QPW1'.
	self assert: 0 equals: power pointValue. ! !

!TestAnalogInput methodsFor: 'test' stamp: 'PoncetAllemand 4/27/2012 15:13'!
testAnalogInputPointValueReturnZeroForNegativeValue

	power pointValue: -1.
	self assert: power pointValue equals: 0.! !

TestCase subclass: #TestRFGenerator
	instanceVariableNames: 'pwrOn myGenerator rfOn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipment-TIT'!

!TestRFGenerator methodsFor: 'Test' stamp: 'PoncetAllemand 4/27/2012 16:22'!
setUp

pwrOn := DigitalInput new.
pwrOn label: 'PWRON'.

rfOn := DigitalInput new.
rfOn label: 'RFON'.

myGenerator := RFGenerator new.
myGenerator
	inputPwrOn: pwrOn;
	inputRfOn: rfOn. ! !

!TestRFGenerator methodsFor: 'Test' stamp: 'PoncetAllemand 4/27/2012 16:08'!
testRfGeneratorPwrOnOffAndRfOnOff

pwrOn stateOff.
rfOn stateOff.
self assert: myGenerator isRunning equals: false.! !

!TestRFGenerator methodsFor: 'Test' stamp: 'PoncetAllemand 4/27/2012 16:48'!
testRfGeneratorPwrOnStateOffAndRfOnStateOn

pwrOn stateOff.
rfOn stateOn.
self assert: myGenerator isRunning equals: false.! !

!TestRFGenerator methodsFor: 'Test' stamp: 'PoncetAllemand 4/27/2012 16:47'!
testRfGeneratorPwrOnStateOnAndRfOnStateOff

pwrOn stateOn.
rfOn stateOff.
self assert: myGenerator isRunning equals: false.! !

!TestRFGenerator methodsFor: 'Test' stamp: 'PoncetAllemand 4/27/2012 16:49'!
testRfGeneratorPwrOnStateOnAndRfOnStateOn

pwrOn stateOn.
rfOn stateOn.
self assert: myGenerator isRunning equals: true.! !
